﻿using System.Collections.Generic;
using EonaCat.Quic.Helpers;

namespace EonaCat.Quic.Infrastructure.Frames;
// This file is part of the EonaCat project(s) which is released under the Apache License.
// See the LICENSE file or go to https://EonaCat.com/License for full license details.

public class MaxStreamDataFrame : Frame
{
    public MaxStreamDataFrame()
    {
    }

    public MaxStreamDataFrame(ulong streamId, ulong maximumStreamData)
    {
        StreamId = streamId;
        MaximumStreamData = maximumStreamData;
    }

    public override byte Type => 0x11;
    public IntegerVar StreamId { get; set; }
    public IntegerVar MaximumStreamData { get; set; }

    public StreamId ConvertedStreamId { get; set; }

    public override void Decode(ByteArray array)
    {
        var type = array.ReadByte();
        StreamId = array.ReadIntegerVar();
        MaximumStreamData = array.ReadIntegerVar();
    }

    public override byte[] Encode()
    {
        var result = new List<byte>
        {
            Type
        };
        result.AddRange(StreamId.ToByteArray());
        result.AddRange(MaximumStreamData.ToByteArray());

        return result.ToArray();
    }
}