﻿using System.Threading.Tasks;

namespace EonaCat.WebSockets;
// This file is part of the EonaCat project(s) which is released under the Apache License.
// See the LICENSE file or go to https://EonaCat.com/License for full license details.

public interface IAsyncWebSocketClientMessageDispatcher
{
    Task OnServerConnected(AsyncWebSocketClient client);
    Task OnServerTextReceived(AsyncWebSocketClient client, string text);
    Task OnServerBinaryReceived(AsyncWebSocketClient client, byte[] data, int offset, int count);
    Task OnServerDisconnected(AsyncWebSocketClient client);

    Task OnServerFragmentationStreamOpened(AsyncWebSocketClient client, byte[] data, int offset, int count);
    Task OnServerFragmentationStreamContinued(AsyncWebSocketClient client, byte[] data, int offset, int count);
    Task OnServerFragmentationStreamClosed(AsyncWebSocketClient client, byte[] data, int offset, int count);
}