﻿using System;

namespace EonaCat.WebSockets.Extensions;
// This file is part of the EonaCat project(s) which is released under the Apache License.
// See the LICENSE file or go to https://EonaCat.com/License for full license details.

public class ValuableParameter<T> : ExtensionParameter
{
    public ValuableParameter(string name, Func<string, bool> valueValidator)
        : base(name)
    {
        if (valueValidator == null)
        {
            throw new ArgumentNullException("valueValidator");
        }

        ValueValidator = valueValidator;
    }

    public override ExtensionParameterType ParameterType => ExtensionParameterType.Valuable;

    public Func<string, bool> ValueValidator { get; private set; }
}