﻿namespace EonaCat.WebSockets;
// This file is part of the EonaCat project(s) which is released under the Apache License.
// See the LICENSE file or go to https://EonaCat.com/License for full license details.

public class FixedHeader
{
    public bool IsFIN { get; set; }
    public bool IsRSV1 { get; set; }
    public bool IsRSV2 { get; set; }
    public bool IsRSV3 { get; set; }
    public OpCode OpCode { get; set; }
    public bool IsMasked { get; set; }

    public override string ToString()
    {
        return
            $"IsFIN[{IsFIN}], IsRSV1[{IsRSV1}], IsRSV2[{IsRSV2}], IsRSV3[{IsRSV3}], OpCode[{OpCode}], IsMasked[{IsMasked}]";
    }
}

public class Header : FixedHeader
{
    public int PayloadLength { get; set; }
    public int MaskingKeyOffset { get; set; }
    public int Length { get; set; }

    public override string ToString()
    {
        return
            $"IsFIN[{IsFIN}], IsRSV1[{IsRSV1}], IsRSV2[{IsRSV2}], IsRSV3[{IsRSV3}], OpCode[{OpCode}], IsMasked[{IsMasked}], PayloadLength[{PayloadLength}], MaskingKeyOffset[{MaskingKeyOffset}], Length[{Length}]";
    }
}