﻿using System;

namespace EonaCat.WebSockets;
// This file is part of the EonaCat project(s) which is released under the Apache License.
// See the LICENSE file or go to https://EonaCat.com/License for full license details.

public sealed class PingFrame : ControlFrame
{
    public PingFrame(bool isMasked = true)
    {
        IsMasked = isMasked;
    }

    public PingFrame(string data, bool isMasked = true)
        : this(isMasked)
    {
        Data = data;
    }

    public string Data { get; private set; }
    public bool IsMasked { get; private set; }

    public override OpCode OpCode => OpCode.Ping;

    public byte[] ToArray(IFrameBuilder builder)
    {
        if (builder == null)
        {
            throw new ArgumentNullException("builder");
        }

        return builder.EncodeFrame(this);
    }
}