﻿using System;

namespace EonaCat.WebSockets;
// This file is part of the EonaCat project(s) which is released under the Apache License.
// See the LICENSE file or go to https://EonaCat.com/License for full license details.

public sealed class TextFrame : DataFrame
{
    public TextFrame(string text, bool isMasked = true)
    {
        if (string.IsNullOrEmpty(text))
        {
            throw new ArgumentNullException("text");
        }

        Text = text;
        IsMasked = isMasked;
    }

    public string Text { get; private set; }
    public bool IsMasked { get; private set; }

    public override OpCode OpCode => OpCode.Text;

    public byte[] ToArray(IFrameBuilder builder)
    {
        if (builder == null)
        {
            throw new ArgumentNullException("builder");
        }

        return builder.EncodeFrame(this);
    }
}