﻿using System.Text;

namespace EonaCat.WebSockets;
// This file is part of the EonaCat project(s) which is released under the Apache License.
// See the LICENSE file or go to https://EonaCat.com/License for full license details.

internal static class StringBuilderExtensions
{
    private static readonly char[] _crcf = { '\r', '\n' };

    public static void AppendFormatWithCrCf(this StringBuilder builder, string format, object arg)
    {
        builder.AppendFormat(format, arg);
        builder.Append(_crcf);
    }

    public static void AppendFormatWithCrCf(this StringBuilder builder, string format, params object[] args)
    {
        builder.AppendFormat(format, args);
        builder.Append(_crcf);
    }

    public static void AppendWithCrCf(this StringBuilder builder, string text)
    {
        builder.Append(text);
        builder.Append(_crcf);
    }

    public static void AppendWithCrCf(this StringBuilder builder)
    {
        builder.Append(_crcf);
    }
}