﻿using System;
using System.Collections.Generic;

namespace EonaCat.WebSockets;
// This file is part of the EonaCat project(s) which is released under the Apache License.
// See the LICENSE file or go to https://EonaCat.com/License for full license details.

public class AsyncWebSocketServerModuleCatalog
{
    private readonly Dictionary<string, AsyncWebSocketServerModule> _modules = new();

    public IEnumerable<AsyncWebSocketServerModule> GetAllModules()
    {
        return _modules.Values;
    }

    public AsyncWebSocketServerModule GetModule(Type moduleType)
    {
        return _modules[moduleType.FullName];
    }

    public void RegisterModule(AsyncWebSocketServerModule module)
    {
        _modules.Add(module.GetType().FullName, module);
    }
}