﻿using System.Threading.Tasks;

namespace EonaCat.WebSockets;
// This file is part of the EonaCat project(s) which is released under the Apache License.
// See the LICENSE file or go to https://EonaCat.com/License for full license details.

public interface IAsyncWebSocketServerMessageDispatcher
{
    Task OnSessionStarted(AsyncWebSocketSession session);
    Task OnSessionTextReceived(AsyncWebSocketSession session, string text);
    Task OnSessionBinaryReceived(AsyncWebSocketSession session, byte[] data, int offset, int count);
    Task OnSessionClosed(AsyncWebSocketSession session);

    Task OnSessionFragmentationStreamOpened(AsyncWebSocketSession session, byte[] data, int offset, int count);
    Task OnSessionFragmentationStreamContinued(AsyncWebSocketSession session, byte[] data, int offset, int count);
    Task OnSessionFragmentationStreamClosed(AsyncWebSocketSession session, byte[] data, int offset, int count);
}